/////////////////////////////////////////////////////////////////////////////////
//
// BkMessage.h
//
// Copyright(C) 2000 YUGA. All rights reserved.
//
/*
 * $Log: BkMessage.h,v $
 * Revision 1.2  2000/08/23 22:26:45  syou
 * - ̏I[s̃oOCBBkCommon.cppABkCommon.hőΏB
 *
 * Revision 1.1  2000/08/06 15:14:41  syou
 * - message/rfc822`Ń[YtĂꍇAYtĂ郁[
 *   ǂ̑ΏۂƂȂ悤ɂBB2(beta23)ȍ~ep[g Content-Typew
 *   ƎQƂ邱ƂmFBAbeta22ȑOgč쐬ꂽ
 *   multipart[̏ꍇ́Â肭Ȃ悤ɎvB
 *   main.cpp剻߁ABclass CPgpb2ǉA
 *   Pgpb2Decode.cppAPgpb2Encode.cppAPgpb2Utility.cppɕčsB
 *   剻ABkMail.h𕪊Bclass`BkMessage.hɏWA
 *   class CBkMessagẽCC֐BkMessage.hɁAclass CBkMailPart̃C
 *   C֐BkMailPart.hɁAclass CBkMail̃CC֐BkMail.hɋL
 *   qA#includeɂABkMessage.h̖Ɏ荞łB
 *   ȊÓAꂼBkMessage.cppABkMailPart.cppABkMail.cppɎB
 *   message/rfc822`̓Yt[ɑΉ邽߁A class CBkRfc822ǉBC
 *   C֐ BkRfc822.hɋLqȂBkRfc822.cppɎBclass
 *   CBkMessage̔hNXÂNXłclass
 *   CBkMessageɈϏB
 *   Encodẽ[`̕ADecodê̂ɓB܂A
 *         CBkMailPartPtr apEncrypt1;
 *         apEncrypt1 = mail.SetChild(new CMIMEItem());
 *
 */


#pragma once


#define CLASS_CBKMESSAGE


#include <windows.h>
#include <stdio.h>
#include <stdlib.h>
#include <mbstring.h>
#include <list>
#include "B2API.h"
#include "../BeckyAPI.h"
#include "../BkCommon.h"
#include "countptr.h"


#define WM_SET_TRANSFER_SAFE    WM_USER+300


/////////////////////////////////////////////////////////////////////////////////
//
/**
 * CBkMessage::FindMIMEItemFirst
 */
#define FINDMIMEITEM_CHILD                  0x00000001
#define FINDMIMEITEM_NEXT                   0x00000002
#define FINDMIMEITEM_FIRST_ONE              0x00000004
#define FINDMIMEITEM_SECOND_ONE             0x00000008
#define FINDMIMEITEM_FIRST_SOME             0x00000010
#define FINDMIMEITEM_SECOND_SOME            0x00000020
#define FINDMIMEITEM_FIRST_CHILD            0x00000041
#define FINDMIMEITEM_FIRST_NEXT             0x00000082

#define FINDMIMEITEM_DEFAULT                FINDMIMEITEM_FIRST_CHILD | \
                                            FINDMIMEITEM_FIRST_SOME | \
                                            FINDMIMEITEM_NEXT | \
                                            FINDMIMEITEM_SECOND_SOME

#define FINDMIMEITEM_UNDER_STAGE            FINDMIMEITEM_FIRST_CHILD   | \
                                            FINDMIMEITEM_FIRST_ONE | \
                                            FINDMIMEITEM_NEXT | \
                                            FINDMIMEITEM_SECOND_SOME


/////////////////////////////////////////////////////////////////////////////////
//
class CBkMailPart;
class CBkMail;
class CBkRfc822;


/////////////////////////////////////////////////////////////////////////////////
//

class CBkMessage
{
public:
    CBkMessage();
    CBkMessage(const CBkMessage& bm);
    virtual ~CBkMessage();
    virtual CBkMessage& operator=(const CBkMessage& bm);

    virtual void GetHeader(LPCTSTR lpHeader, LPSTR lpszBuf, int nBuf);
    virtual void SetHeader(LPCTSTR lpHeader, LPCTSTR lpData);
    virtual void EmptyHeaders();
    virtual void EmptyBody();
    virtual void EmptyTrail();
    virtual void AddHeadersFront(LPSTR lpLine);
    virtual void AddBodyFront(LPSTR lpLine);
    virtual void AddTrailFront(LPSTR lpLine);
    virtual void AddHeadersTail(LPSTR lpLine);
    virtual void AddBodyTail(LPSTR lpLine);
    virtual void AddTrailTail(LPSTR lpLine);
    virtual void FromString(LPSTR lpszSrc, LPCTSTR lpBoundary=NULL);
    virtual LPSTR ToString();
    virtual BOOL IsMIMEItem(LPCTSTR lpszType, LPCTSTR lpszSubType);
    virtual LPCTSTR GetMIMEType();
    virtual LPCTSTR GetMIMESubType();
    virtual LPCTSTR GetMIMEBoundary();

    virtual CBkMailPart* SetChild(CMIMEItem* pChild) = 0;
    virtual CBkMailPart* AddChild(CMIMEItem* pChild) = 0;
    virtual CBkMailPart* SetNext(CMIMEItem* pNext) = 0;
    virtual CBkMailPart* GetChild() = 0;
    virtual CBkMailPart* GetNext() = 0;
    virtual CBkRfc822* GetRfc822() = 0;
    virtual CBkMailPart* FindMIMEItemFirst(LPCTSTR lpszType, LPCTSTR lpszSubType, DWORD dwFlag) = 0;
    virtual CBkMailPart* FindMIMEItemNext() = 0;

    virtual void NotifyChanged() = 0;
    virtual LPSTR GetPGPOriginalText(BOOL bPGPMIME) = 0;


protected:
    virtual void SetContentType(LPCTSTR lpHeader, LPCTSTR lpData);
    virtual void ExploreItemTree(LPCTSTR lpszType, LPCTSTR lpszSubType, CMIMEItem* pItem, DWORD dwFlag);

    CB2API* m_pbka;
    CMIMEItem* m_pItem;
    std::list<CMIMEItem*> m_listItem;
    std::list<CMIMEItem*>::iterator m_iMimeItem;

private:
};


/////////////////////////////////////////////////////////////////////////////////
//
typedef count_ptr<CBkMessage>   CBkMessagePtr;


/////////////////////////////////////////////////////////////////////////////////
//

class CBkMailPart : public CBkMessage
{
public:
    // CBkMailPart
    CBkMailPart(const CBkMailPart& bmp);
    CBkMailPart(CBkMessage* pbmParent, CMIMEItem* pItem);
    virtual ~CBkMailPart() {}
    CBkMailPart& operator=(const CBkMailPart& bmp);

    // CBkMessage
    CBkMailPart* SetChild(CMIMEItem* pChild);
    CBkMailPart* AddChild(CMIMEItem* pChild);
    CBkMailPart* SetNext(CMIMEItem* pNext);
    CBkMailPart* GetChild();
    CBkMailPart* GetNext();
    CBkRfc822* GetRfc822();
    CBkMailPart* FindMIMEItemFirst(LPCTSTR lpszType, LPCTSTR lpszSubType, DWORD dwFlag);
    CBkMailPart* FindMIMEItemNext();

    void NotifyChanged();
    LPSTR GetPGPOriginalText(BOOL bPGPMIME);

    // CBkMailPart
    CBkMessage* GetParent() const;

protected:

private:
    CBkMessage* m_pbmParent;
};


/////////////////////////////////////////////////////////////////////////////////
//
typedef count_ptr<CBkMailPart>  CBkMailPartPtr;


/////////////////////////////////////////////////////////////////////////////////
//
class CBkMail : public CBkMessage
{
public:
    // CBkMail
    CBkMail(const CBkMail& bm);
    virtual ~CBkMail();
    CBkMail& operator=(const CBkMail& bm);

    // CBkMessage
    LPCTSTR GetSource();
    //void DeleteItem(CMIMEItem* pItem);
    void GetHeader(LPCTSTR lpHeader, LPSTR lpszBuf, int nBuf);
    void SetHeader(LPCTSTR lpHeader, LPCTSTR lpData);
    void EmptyHeaders();
    void EmptyBody();
    void EmptyTrail();
    void AddHeadersFront(LPSTR lpLine);
    void AddBodyFront(LPSTR lpLine);
    void AddTrailFront(LPSTR lpLine);
    void AddHeadersTail(LPSTR lpLine);
    void AddBodyTail(LPSTR lpLine);
    void AddTrailTail(LPSTR lpLine);

    BOOL IsMIMEItem(LPCTSTR lpszType, LPCTSTR lpszSubType);
    LPCTSTR GetMIMEType();
    LPCTSTR GetMIMESubType();
    LPCTSTR GetMIMEBoundary();
    CBkMailPart* SetChild(CMIMEItem* pChild);
    CBkMailPart* AddChild(CMIMEItem* pChild);
    CBkMailPart* SetNext(CMIMEItem* pNext);
    CBkMailPart* GetChild();
    CBkMailPart* GetNext();
    CBkRfc822* GetRfc822();
    CBkMailPart* FindMIMEItemFirst(LPCTSTR lpszType, LPCTSTR lpszSubType, DWORD dwFlag);
    CBkMailPart* FindMIMEItemNext();
    void NotifyChanged();

    // CBkMail
    explicit CBkMail(HWND hWnd);
    explicit CBkMail(LPCTSTR lpMailID);
    BOOL Commit();
    void ReloadSource();
    BOOL SetText(int nMode, LPCTSTR lpszText);
    void GetCharSet(LPSTR lpszCharSet, int nBuf) const;

    LPSTR GetPGPOriginalText(BOOL bPGPMIME);

protected:
    // CBkMessage
    LPCTSTR GetContent();

    // CBkMail
    LPSTR GetText();
    void LoadSource();

    CPointerList m_lstItems;

private:
    HWND m_hWnd;
    LPSTR m_lpSource;
    LPSTR m_lpMailID;
    BOOL m_bChanged;
};


/////////////////////////////////////////////////////////////////////////////////
//
typedef count_ptr<CBkMail>      CBkMailPtr;


/////////////////////////////////////////////////////////////////////////////////
//

class CBkRfc822 : public CBkMessage
{
public:
    // CBkRfc822
    CBkRfc822(const CBkRfc822& br);
    //CBkRfc822(CBkMessage* pbm, CMIMEItem* pItem);
    explicit CBkRfc822(CMIMEItem* pItem);
    virtual ~CBkRfc822();
    CBkRfc822& operator=(const CBkRfc822& br);

    // CBkMessage
    CBkMailPart* SetChild(CMIMEItem* pChild);
    CBkMailPart* AddChild(CMIMEItem* pChild);
    CBkMailPart* SetNext(CMIMEItem* pNext);
    CBkMailPart* FindMIMEItemFirst(LPCTSTR lpszType, LPCTSTR lpszSubType, DWORD dwFlag);
    CBkMailPart* FindMIMEItemNext();
    CBkMailPart* GetChild();
    CBkMailPart* GetNext();
    CBkRfc822* GetRfc822();
    LPSTR GetPGPOriginalText(BOOL bPGPMIME);
    void NotifyChanged();

protected:
private:
    BOOL m_bChanged;
};


/////////////////////////////////////////////////////////////////////////////////
//
typedef count_ptr<CBkRfc822>    CBkRfc822Ptr;


/////////////////////////////////////////////////////////////////////////////////
// CBkMessage inline function
inline LPSTR CBkMessage::ToString()
{
    return m_pItem->ToString();
}


inline void CBkMessage::FromString(LPSTR lpszSrc, LPCTSTR lpBoundary)
{
    m_pItem->FromString(lpszSrc, lpBoundary);
}



inline void CBkMessage::GetHeader(LPCTSTR lpHeader, LPSTR lpszBuf, int nBuf)
{
    m_pItem->GetHeader(lpHeader, lpszBuf, nBuf);
}


inline void CBkMessage::SetHeader(LPCTSTR lpHeader, LPCTSTR lpData)
{
    if (strnicmp(lpHeader, "Content-Type", 12) == 0) {
        SetContentType(lpHeader, lpData);
    }
    m_pItem->SetHeader(lpHeader, lpData);
}


inline void CBkMessage::EmptyHeaders()
{
    m_pItem->m_lstHeaders.Empty();
    NotifyChanged();
}


inline void CBkMessage::AddHeadersFront(LPSTR lpLine)
{
    CPointerItem* pTop = m_pItem->m_lstHeaders.GetTop();
    if (pTop) {
        m_pItem->m_lstHeaders.InsertBefore(pTop, lpLine);
    }
    else {
        m_pItem->m_lstHeaders.AddTail(lpLine);
    }
    NotifyChanged();
}


inline void CBkMessage::AddHeadersTail(LPSTR lpLine)
{
    m_pItem->m_lstHeaders.AddTail(lpLine);
    NotifyChanged();
}


inline void CBkMessage::EmptyBody()
{
    m_pItem->m_lstBody.Empty();
    NotifyChanged();
}


inline void CBkMessage::AddBodyFront(LPSTR lpLine)
{
    CPointerItem* pTop = m_pItem->m_lstBody.GetTop();
    if (pTop) {
        m_pItem->m_lstBody.InsertBefore(pTop, lpLine);
    }
    else {
        m_pItem->m_lstBody.AddTail(lpLine);
    }
    NotifyChanged();
}


inline void CBkMessage::AddBodyTail(LPSTR lpLine)
{
    m_pItem->m_lstBody.AddTail(lpLine);
    NotifyChanged();
}


inline void CBkMessage::EmptyTrail()
{
    m_pItem->m_lstTrail.Empty();
    NotifyChanged();
}


inline void CBkMessage::AddTrailFront(LPSTR lpLine)
{
    CPointerItem* pTop = m_pItem->m_lstTrail.GetTop();
    if (pTop) {
        m_pItem->m_lstTrail.InsertBefore(pTop, lpLine);
    }
    else {
        m_pItem->m_lstTrail.AddTail(lpLine);
    }
    NotifyChanged();
}


inline void CBkMessage::AddTrailTail(LPSTR lpLine)
{
    m_pItem->m_lstTrail.AddTail(lpLine);
    NotifyChanged();
}


inline LPCTSTR CBkMessage::GetMIMEType()
{
    return m_pItem->m_szType;
}


inline LPCTSTR CBkMessage::GetMIMESubType()
{
    return m_pItem->m_szSubType;
}


inline LPCTSTR CBkMessage::GetMIMEBoundary()
{
    return m_pItem->m_lpBoundary;
}


/////////////////////////////////////////////////////////////////////////////////
// include inline functions


#include "BkMailPart.h"
#include "BkMail.h"
#include "BkRfc822.h"


/////////////////////////////////////////////////////////////////////////////////
//


