/////////////////////////////////////////////////////////////////////////////////
//
// BkRfc822.cpp
//
// Copyright (C) 2000 YUGA. All rights reserved.
//
/*
 * $Log: BkRfc822.cpp,v $
 * Revision 1.1  2000/08/06 15:14:41  syou
 * - message/rfc822`Ń[YtĂꍇAYtĂ郁[
 *   ǂ̑ΏۂƂȂ悤ɂBB2(beta23)ȍ~ep[g Content-Typew
 *   ƎQƂ邱ƂmFBAbeta22ȑOgč쐬ꂽ
 *   multipart[̏ꍇ́Â肭Ȃ悤ɎvB
 *   main.cpp剻߁ABclass CPgpb2ǉA
 *   Pgpb2Decode.cppAPgpb2Encode.cppAPgpb2Utility.cppɕčsB
 *   剻ABkMail.h𕪊Bclass`BkMessage.hɏWA
 *   class CBkMessagẽCC֐BkMessage.hɁAclass CBkMailPart̃C
 *   C֐BkMailPart.hɁAclass CBkMail̃CC֐BkMail.hɋL
 *   qA#includeɂABkMessage.h̖Ɏ荞łB
 *   ȊÓAꂼBkMessage.cppABkMailPart.cppABkMail.cppɎB
 *   message/rfc822`̓Yt[ɑΉ邽߁A class CBkRfc822ǉBC
 *   C֐ BkRfc822.hɋLqȂBkRfc822.cppɎBclass
 *   CBkMessage̔hNXÂNXłclass
 *   CBkMessageɈϏB
 *   Encodẽ[`̕ADecodê̂ɓB܂A
 *         CBkMailPartPtr apEncrypt1;
 *         apEncrypt1 = mail.SetChild(new CMIMEItem());
 *
 */


#include "BkMessage.h"


/////////////////////////////////////////////////////////////////////////////////
//
CBkRfc822::CBkRfc822(const CBkRfc822& br)
{
    m_bChanged = br.m_bChanged;
}


CBkRfc822::CBkRfc822(CMIMEItem* pItem)
{
    m_pItem = pItem;
    m_bChanged = FALSE;
}


CBkRfc822& CBkRfc822::operator =(const CBkRfc822& br)
{
    CBkMessage::operator =(br);
    if (this != &br) {
        m_bChanged = br.m_bChanged;
    }
    return *this;
}


CBkRfc822::~CBkRfc822()
{
    delete m_pItem;
}


CBkMailPart* CBkRfc822::SetChild(CMIMEItem* pChild)
{
    m_pItem->SetChild(pChild);
    NotifyChanged();
    if (pChild == NULL) {
        return NULL;
    }
    return new CBkMailPart(this, pChild);
}


CBkMailPart* CBkRfc822::AddChild(CMIMEItem* pChild)
{
    if (pChild == NULL) {
        return NULL;
    }
    m_pItem->AddChild(pChild);
    NotifyChanged();
    if (pChild == NULL) {
        return NULL;
    }
    return new CBkMailPart(this, pChild);
}


CBkMailPart* CBkRfc822::SetNext(CMIMEItem* pNext)
{
    m_pItem->SetNext(pNext);
    NotifyChanged();
    if (pNext == NULL) {
        return NULL;
    }
    return new CBkMailPart(this, pNext);
}



CBkMailPart* CBkRfc822::FindMIMEItemFirst(LPCTSTR lpszType, LPCTSTR lpszSubType, DWORD dwFlag)
{
    m_listItem.clear();
    ExploreItemTree(lpszType, lpszSubType, m_pItem, dwFlag);
    if (m_listItem.empty()) {
        return NULL;
    }

    m_iMimeItem = m_listItem.begin();
    if (m_iMimeItem == m_listItem.end()) {
        return NULL;
    }

    return new CBkMailPart(this, *m_iMimeItem);
}


CBkMailPart* CBkRfc822::FindMIMEItemNext()
{
    if (++m_iMimeItem == m_listItem.end()) {
        return NULL;
    }

    return new CBkMailPart(this, *m_iMimeItem);
}


CBkRfc822* CBkRfc822::GetRfc822()
{
    LPSTR lpSource = m_pItem->ToString();
    LPCTSTR lpContent = strstr(lpSource, "\r\n\r\n");
    if (lpContent == NULL) {
        free(lpSource);
        return NULL;
    }
    lpContent += 2;

    if (*lpContent == NULL) {
        free(lpSource);
        return NULL;
    }

    LPSTR lpTemp = const_cast<LPSTR>(lpContent);
    CMIMEItem* pItem = new CMIMEItem();
    pItem->FromString(lpTemp);
    free(lpSource);

    return new CBkRfc822(pItem);
}


LPSTR CBkRfc822::GetPGPOriginalText(BOOL bPGPMIME)
{
    LPSTR lpTxt = NULL;
    if (bPGPMIME) {

        LPSTR lpSource = m_pItem->ToString();
        LPCTSTR lpContent = strstr(lpSource, "\r\n\r\n");
        if (lpContent == NULL) {
            free(lpSource);
            return NULL;
        }
        lpContent += 2;

        if (*lpContent == NULL) {
            free(lpSource);
            return NULL;
        }

        lpTxt = (LPSTR) malloc(strlen(lpContent) + 3072);//m_pbka->Alloc(strlen(lpContent) + 3072);
        if (lpTxt == NULL) {
            free(lpSource);
            return NULL;
        }

        char szType[1024];
        char szEncoding[1024];
        GetHeader("Content-Type", szType, 1024);
        GetHeader("Content-Transfer-Encoding", szEncoding, 1024);
        sprintf(lpTxt, "Content-Type: %sContent-Transfer-Encoding: %s%s", szType, szEncoding, lpContent);
        free(lpSource);
    }
    return lpTxt;
}



