////////////////////////////////////////////////////////////////////////////////////
//
// Pgpb2Decode.cpp
//
// Copyright (C) 2000 YUGA. All rights reserved.
//
/*
 * $Log: Pgpb2Decode.cpp,v $
 * Revision 1.2  2000/08/23 22:26:45  syou
 * - ̏I[s̃oOCBBkCommon.cppABkCommon.hőΏB
 *
 * Revision 1.1  2000/08/06 15:14:42  syou
 * - message/rfc822`Ń[YtĂꍇAYtĂ郁[
 *   ǂ̑ΏۂƂȂ悤ɂBB2(beta23)ȍ~ep[g Content-Typew
 *   ƎQƂ邱ƂmFBAbeta22ȑOgč쐬ꂽ
 *   multipart[̏ꍇ́Â肭Ȃ悤ɎvB
 *   main.cpp剻߁ABclass CPgpb2ǉA
 *   Pgpb2Decode.cppAPgpb2Encode.cppAPgpb2Utility.cppɕčsB
 *   剻ABkMail.h𕪊Bclass`BkMessage.hɏWA
 *   class CBkMessagẽCC֐BkMessage.hɁAclass CBkMailPart̃C
 *   C֐BkMailPart.hɁAclass CBkMail̃CC֐BkMail.hɋL
 *   qA#includeɂABkMessage.h̖Ɏ荞łB
 *   ȊÓAꂼBkMessage.cppABkMailPart.cppABkMail.cppɎB
 *   message/rfc822`̓Yt[ɑΉ邽߁A class CBkRfc822ǉBC
 *   C֐ BkRfc822.hɋLqȂBkRfc822.cppɎBclass
 *   CBkMessage̔hNXÂNXłclass
 *   CBkMessageɈϏB
 *   Encodẽ[`̕ADecodê̂ɓB܂A
 *         CBkMailPartPtr apEncrypt1;
 *         apEncrypt1 = mail.SetChild(new CMIMEItem());
 *
 */


#include "Pgpb2.h"


////////////////////////////////////////////////////////////////////////
//
CPgpb2::CPgpb2()
{
    m_pbka = CB2API::Instance();
    m_bPGPMIME = TRUE;
}


CPgpb2::~CPgpb2()
{
}


////////////////////////////////////////////////////////////////////////
// PGP decode
BOOL CPgpb2::PGPIncoming1(HWND hWnd, PGPContextRef context)
{
    HWND hMain, hTree, hList, hView;
    if (!m_pbka->GetWindowHandles(&hMain, &hTree, &hList, &hView)) {
        return FALSE;
    }

    if (hMain != hWnd) {
        return FALSE;
    }

    LPCTSTR lpMailID = m_pbka->GetCurrentMail();
    if (lpMailID == NULL) {
        return FALSE;
    }

    // ݂̃[擾 -------------
    CBkMail mail(lpMailID);

    // multipartAsignedtypemime part -------------
    BOOL bDecode = DecodePgpMailPart(mail, hWnd, context);

    if (bDecode) {
        LPSTR lpTempSource = mail.ToString();
        /*
        FILE* fp;
        fp = fopen("E:\\syou\\mail.txt", "wb");
        fwrite(lpTempSource, strlen(lpTempSource), 1, fp);
        fclose(fp);
        */
        if (lpTempSource == NULL) {
            return FALSE;
        }
        m_pbka->SetSource("TEMP", lpTempSource);
        free(lpTempSource);
    }

    return TRUE;
}


////////////////////////////////////////////////////////////////////////
//
BOOL CPgpb2::DecodePgpMailPart(CBkMessage& mail, HWND hWnd, PGPContextRef context)
{
    BOOL bDecode = FALSE;
    bDecode = DecodePgpMailPart2(mail, hWnd, context);

    CBkMailPartPtr bmpTop;
    bmpTop = mail.FindMIMEItemFirst("message", "rfc822", FINDMIMEITEM_DEFAULT);
    while (bmpTop.get()) {
        CBkRfc822Ptr bkRfc822;
        bkRfc822 = bmpTop->GetRfc822();
        if (DecodePgpMailPart(*bkRfc822, hWnd, context)) {
            LPSTR lpSource = bkRfc822->ToString();
            bmpTop->EmptyBody();
            bmpTop->AddBodyTail(lpSource);
            free(lpSource);
            bDecode = TRUE;
        }
        bmpTop = mail.FindMIMEItemNext();
    }

    return bDecode;
}


BOOL CPgpb2::DecodePgpMailPart2(CBkMessage& mail, HWND hWnd, PGPContextRef context)
{
    BOOL bDecode = FALSE;
    CBkMailPartPtr bmpTop;
    bmpTop = mail.FindMIMEItemFirst("multipart", "encrypted", FINDMIMEITEM_DEFAULT);
    while (bmpTop.get()) {
        if (PGPDecrypt(bmpTop, hWnd, context)) {
            DecodePgpMailPart2(*bmpTop, hWnd, context);
            bDecode = TRUE;
        }
        bmpTop = mail.FindMIMEItemNext();
    }
    bmpTop =  mail.FindMIMEItemFirst("multipart", "signed", FINDMIMEITEM_DEFAULT);
    while (bmpTop.get()) {
        bDecode |= PGPVerifyDetachedSignature(bmpTop, hWnd, context);
        bmpTop = mail.FindMIMEItemNext();
    }

    return bDecode;
}


////////////////////////////////////////////////////////////////////////
// PGP
BOOL CPgpb2::PGPVerifyDetachedSignature(CBkMailPartPtr mail, HWND hWnd, PGPContextRef context)
{
    // MIMEACeAPGP/MIMEp[gT
    //
    // PGP/MIME͉̎L̂悤ȃC[W
    // (1)ep[g
    //    (2){iꂽbZ[WjF(1)GetChild()Ŏ擾
    //    (3)F(2)GetNext()Ŏ擾
    //
    CBkMailPartPtr bmpContent;
    bmpContent = mail->GetChild();
    if (bmpContent.get() == NULL || bmpContent->IsMIMEItem("application", "pgp-signature")) {
        return FALSE;
    }

    CBkMailPartPtr bmpSign;
    bmpSign = bmpContent->GetNext();
    if (bmpSign.get() == NULL || !bmpSign->IsMIMEItem("application", "pgp-signature")) {
        return FALSE;
    }

    // PGP/MIMEꂽbZ[W̐ep[g(3)̃\[X擾
    LPSTR lpPgp = bmpSign->ToString();
    if (lpPgp == NULL) {
        return FALSE;
    }

    // ۂɏ݂邩A擪"-----BEGIN PGP SIGNATURE-----"݂̑mF
    LPSTR lpSign = strstr(lpPgp, "-----BEGIN PGP SIGNATURE-----");
    if (lpSign == NULL) {
        free(lpPgp);
        return FALSE;
    }

    // PGP/MIMEɑΉ{(2)Ă鎞
    // (2)̃\[X擾
    LPSTR lpBody = NULL;
    lpBody = bmpContent->ToString();
    if (lpBody == NULL) {
        free(lpPgp);
        return FALSE;
    }

    // ̉sR[h폜
    //CutBufferEndCRLF(lpBody);

    /* ==== Verify a detached Signature code fragment =============== */
    /* Declare and initialize variables */
    PGPError err = kPGPError_NoErr;
    PGPKeySetRef defaultKeyRing = kInvalidPGPKeySetRef;
    CSignatureListener sigListener;

    /* ---- Prepare Decryption Operation Parameters ------------- */
    /* Open the default keyring */
    err = PGPOpenDefaultKeyRings(context, kPGPKeyRingOpenFlags_Mutable, &defaultKeyRing);
    if (IsPGPError(err)) {
        goto Exit;
    }
    /* ---- Perform the Verify operation ------------- */
    /* This is the main event; everything above and
    * below exists only to support this call.
    *
    * NOTE: Verification results are determined in the event handler
    * function, myEventHandler(), not here.
    */
    err = PGPDecode(context,
            PGPOKeySetRef(context, defaultKeyRing),
            PGPOSetEventHandler(context, &sigListener),
            PGPOInputBuffer(context, lpSign, strlen(lpSign)),
            PGPODetachedSig(context,
                PGPOInputBuffer(context, lpBody, strlen(lpBody)),
                PGPOLastOption(context)),
            PGPOLastOption(context) );
    if (IsPGPError(err)) {
        goto Exit;
    }

    /* Test validity of signature here */
    if (sigListener.IsSigned()) {
        ExplainSigningMessage(*mail, sigListener);
    }


Exit:

    free(lpBody);
    free(lpPgp);
    lpBody = NULL;
    lpPgp = NULL;
    lpSign = NULL;

    /* ---- Release resources used in this operation ------------- */
    if (PGPKeySetRefIsValid(defaultKeyRing))
        PGPFreeKeySet(defaultKeyRing);

    return TRUE;
}


////////////////////////////////////////////////////////////////////////
// PGP
BOOL CPgpb2::PGPDecrypt(CBkMailPartPtr mail, HWND hWnd, PGPContextRef context)
{
    CBkMailPartPtr bmpContent;
    bmpContent = mail->GetChild();
    if (bmpContent.get() == NULL || !bmpContent->IsMIMEItem("application", "pgp-encrypted")) {
        return FALSE;
    }

    CBkMailPartPtr bmpEncrypt;
    bmpEncrypt = bmpContent->GetNext();
    if (bmpEncrypt.get() == NULL || !bmpEncrypt->IsMIMEItem("application", "octet-stream")) {
        return FALSE;
    }

    // PGP/MIMËÍ̃\[X擾
    LPSTR lpEncrypt = bmpEncrypt->ToString();
    if (lpEncrypt == NULL) {
        return FALSE;
    }

    // Í̃\[X
    LPSTR lpPgp = strstr(lpEncrypt, "-----BEGIN PGP ");
    if (lpPgp == NULL) {
        free(lpEncrypt);
        return FALSE;
    }

    /* Declare and initialize variables */
    BOOL result = FALSE;
    PGPError err = kPGPError_NoErr;
    PGPKeySetRef defaultKeyRing = kInvalidPGPKeySetRef;
    LPSTR lpArea = NULL;
    PGPSize outputSize = 0;
    PGPSize inputSize = strlen(lpPgp);
    CDecryptListener decListener;
    decListener.SetWindowHandle(hWnd);

    /* ---- Prepare Decryption Operation Parameters ------------- */
    /* Open the default keyring */
    err = PGPOpenDefaultKeyRings(context, kPGPKeyRingOpenFlags_Mutable, &defaultKeyRing);
    if (IsPGPError(err)) {
        goto Exit;
    }

    /* ---- Perform the Decryption operation ------------- */
    /* This is the main event; everything above and
    * below exists only to support this call.
    *
    * Produces the decrypted output file in the default directory.
    */
    err = PGPDecode(context,
            PGPOInputBuffer(context, lpPgp, inputSize),
            PGPOAllocatedOutputBuffer(context, reinterpret_cast<void**>(&lpArea), MAX_PGPInt32, &outputSize),
            PGPOKeySetRef(context, defaultKeyRing),
            PGPOSetEventHandler(context, &decListener),
            PGPOLastOption(context)
            );

    if (IsPGPError(err)) {
        goto Exit;
    }

    if (lpArea) {
        CBkMailPartPtr bmpDecrypt;
        bmpDecrypt = mail->SetChild(new CMIMEItem());
        bmpDecrypt->FromString(lpArea);
        PGPFreeData(lpArea);

        /* Test validity of signature here */
        if (decListener.IsSigned()) {
            ExplainSigningMessage(*mail, decListener);
        }
        else {
            char szBuf[32768];
            LPCTSTR lpBoundary = mail->GetMIMEBoundary();
            sprintf(szBuf, "multipart/mixed; boundary=\"%s\"\r\n", lpBoundary);
            mail->SetHeader("Content-Type", szBuf);
        }

        result = TRUE;
    }

Exit:
    free(lpEncrypt);

    return result;
}


////////////////////////////////////////////////////////////////////////
// ̐}
BOOL CPgpb2::ExplainSigningMessage(CBkMessage& mail, CSignatureListener& sigListener)
{
    /* Test validity of signature here */
    if (!sigListener.IsSigned()) {
        return FALSE;
    }

    char szBuf[32768];
    LPCTSTR lpBoundary = mail.GetMIMEBoundary();
    sprintf(szBuf, "multipart/mixed; boundary=\"%s\"\r\n", lpBoundary);
    mail.SetHeader("Content-Type", szBuf);

    // PGPB2̃bZ[W
    CBkMailPartPtr bmpPgpb2Mes;
    bmpPgpb2Mes= mail.AddChild(new CMIMEItem());
    bmpPgpb2Mes->SetHeader("Content-Transfer-Encoding", "8bit\r\n\r\n");
    bmpPgpb2Mes->SetHeader("Content-Type", "text/plain; charset=\"Shift_JIS\"\r\n");
    bmpPgpb2Mes->AddBodyTail("̃[PGP/MIMEĂ܂B\r\n");

    if (sigListener.IsChecked())
    {
        /* There was a signature in the file */
        if (sigListener.IsVerified())
        {
            /* The signature verified */
            char szBufGmt[1024];
            char szBufLmt[1024];
            time_t creationTime;

            sprintf(szBuf, "%s̐łB\r\n", sigListener.GetName());
            bmpPgpb2Mes->AddBodyTail(szBuf);
            creationTime = PGPGetStdTimeFromPGPTime(sigListener.GetData().creationTime);
            strftime(szBufGmt, 1024, "%Y/%m/%d %H:%M:%S GMT", gmtime(&creationTime));
            strftime(szBufLmt, 1024, "%Y/%m/%d %H:%M:%S %Z", localtime(&creationTime));
            sprintf(szBuf, " %s (%s) ɍ쐬܂B\r\n", szBufGmt, szBufLmt);
            bmpPgpb2Mes->AddBodyTail(szBuf);
        }
        else
        {
            sprintf(szBuf, "%s̕sȏłB\r\n", sigListener.GetName());
            bmpPgpb2Mes->AddBodyTail(szBuf);
            bmpPgpb2Mes->AddBodyTail("{̓eƏv܂B\r\n");
        }
    }
    else {
        switch (sigListener.GetKeyValidity()) {
        case kPGPValidity_Unknown:
            strcpy(szBuf, "̏؂邽߂̌J܂B\r\n");
            break;
        case kPGPValidity_Marginal:
        case kPGPValidity_Invalid:
            strcpy(szBuf, "sȏłB\r\n");
        default:
            strcpy(szBuf, "");
            break;
        }

        bmpPgpb2Mes->AddBodyTail(szBuf);
    }
    bmpPgpb2Mes->AddBodyTail("------------------------------------------------------------ by PGPB2\r\n");

    return TRUE;
}
