/////////////////////////////////////////////////////////////////////////////////
//
// SignatureListener.cpp
//
// Copyright (C) 2000 YUGA. All rights reserved.
//
/*
 * $Log: SignatureListener.cpp,v $
 * Revision 1.2  2000/07/15 02:09:56  syou
 * - PGP/MIMEÍƏꂽ[̏؂Bclass
 *   CDecryptListenerclass CSignatureListenerhAPGP/MIME
 *   ꂽ[̏؂ƁA\[`LBƂ
 *   CɂȂ̂͂2̃NX̖OAPGPEventtׂH
 *
 * Revision 1.1  2000/07/13 15:12:24  syou
 * - PGP/MIME`̈Í[̕B
 *   PGPEventHandlerAeListenerƂɎ悤ɂBclass CEventListener
 *   hIuWFNgEventHandlerꂼĎgB
 *   SignatureData.h폜AEventListener.hAEventListener.cppASignatureListener.h
 *   SignatureListener.cppADecryptListener.hADecryptListener.cppǉB
 *   count_ptr<CBkMailPart*>CBkMailPartPtrtypedefB
 *   \[XSʂɓnāAfree(memoryblock*)̑OmemoryblockNULLłȂ
 *   `FbNĂ̂AMSDNCu[̃QW[t@XQƂɍ폜B
 *
 */


#include <windows.h>
#include "SignatureListener.h"


/////////////////////////////////////////////////////////////////////////////////
//
CSignatureListener::CSignatureListener()
{
    name = NULL;
    bSigned = FALSE;
    ::ZeroMemory(&sigData.signingKeyID, sizeof(sigData.signingKeyID));
    sigData.signingKey = kInvalidPGPKeyRef;
    sigData.checked = FALSE;
    sigData.verified = FALSE;
    sigData.keyRevoked = FALSE;
    sigData.keyDisabled = FALSE;
    sigData.keyExpired = FALSE;
    sigData.keyMeetsValidityThreshold = FALSE;
    sigData.keyValidity = kPGPValidity_Unknown;
    sigData.creationTime = kPGPExpirationTime_Never;
}


CSignatureListener::~CSignatureListener()
{
    delete [] name;
    name = NULL;
}


const PGPEventSignatureData CSignatureListener::GetData() const
{
    return sigData;
}


const char* CSignatureListener::GetName() const
{
    return name;
}


const PGPValidity CSignatureListener::GetKeyValidity() const
{
    return sigData.keyValidity;
}


BOOL CSignatureListener::IsChecked() const
{
    return sigData.checked;
}


BOOL CSignatureListener::IsVerified() const
{
    return sigData.verified;
}


BOOL CSignatureListener::IsSigned() const
{
    return bSigned;
}


void CSignatureListener::SetSignatureEventData(PGPEvent* event)
{
    PGPEventSignatureData* data = reinterpret_cast<PGPEventSignatureData*>(&event->data.signatureData);
    sigData.signingKeyID = data->signingKeyID;
    sigData.signingKey = kInvalidPGPKeyRef;
    sigData.checked = data->checked;
    sigData.verified = data->verified;
    sigData.keyRevoked = data->keyRevoked;
    sigData.keyDisabled = data->keyDisabled;
    sigData.keyExpired = data->keyExpired;
    sigData.keyMeetsValidityThreshold = data->keyMeetsValidityThreshold;
    sigData.keyValidity = data->keyValidity;
    sigData.creationTime = data->creationTime;

    if (data->signingKey != kInvalidPGPKeyRef) {
        delete [] name;
        name = NULL;
        PGPSize namelen = 0;
        PGPGetPrimaryUserIDNameBuffer(data->signingKey, namelen, name, &namelen);
        name = new char[namelen+1];
        PGPGetPrimaryUserIDNameBuffer(data->signingKey, namelen, name, &namelen);
    }
}


PGPError CSignatureListener::ListenEvent(PGPContextRef context, PGPEvent* event)
{
    /* branch on the received event code */
    PGPError err = kPGPError_NoErr;
    switch(event->type)
    {
    case kPGPEvent_SignatureEvent:
        bSigned = TRUE;
        SetSignatureEventData(event);
        break;
    default:
        break;
    }

    return err;
}
